;VramAdress = 0
;Size = 0
;BankNumber = 2
;TileAdress = 4

start_animation_engine:
  rep #$30
  ldx #$0000
  stz a:16x16RequestCounter
  stz a:32x32RequestCounter

animation_table_finder:
  lda AnimationFrame
  clc
  adc AnimationCounter
  tay
  lda a:AnimationTableBegining,y
  cmp #$0000
  bcc animation_table_reader_done	;Needs expansion
  tay
  inc AnimationCounter
  

animation_table_reader_loop:
  lda a:Size,y
  beq animation_table_reader_done
  cmp #$0080
  beq animation_table_reader_32x32

animation_table_reader_16x16:
  ldx a:16x16TileRequestCounter
  sta a:32x32TileRequestTable+Size,x
  lda a:BankNumber,y
  sta a:32x32TileRequestTable+BankNumber,x
  lda a:TileAddress,y
  sta a:32x32TileRequestTable+TileAddress,x

  tya
  clc
  adc #$0006
  tay
  txa
  clc
  adc #$0006
  sta a:16x16TileRequestCounter
  bra animation_table_reader_loop

animation_table_reader_32x32:
  ldx a:32x32TileRequestCounter
  sta a:32x32TileRequestTable+Size,x
  lda a:BankNumber,y
  sta a:32x32TileRequestTable+BankNumber,x
  lda a:TileAddress,y
  sta a:32x32TileRequestTable+TileAddress,x

  tya
  clc
  adc #$0006
  tay
  txa
  clc
  adc #$0006
  sta a:32x32TileRequestCounter
  bra animation_table_reader_loop



animation_table_reader_done:
  tdc
  clc
  adc #$30
  tcd
  cmp #6144+ObjectTable
  bne animation_table_finder
  rts