.segment "CODE"

;
; start_metasprite
;
.proc start_palette_uploader
  sep #$30
  ldx #$00
  lda #$80
  sta DMAPaletteOffset
  
palette_uploader_loop:
  lda DMAPaletteOffset
  sta $2121
  
  lda OnscreenPaletteTable,x
  beq prepare_for_palette_uploader_loop

  tay
  rep #$30   ; A=16, X/Y=16
  lda PaletteAddressTable-2,y
  
  sta $4302
  sep #$30
  lda #$00
  sta $4304
  lda #$20
  sta $4305

  stz $4300
  lda #$22
  sta $4301
  lda #$01
  sta $420B

  lda DMAPaletteOffset
  clc
  adc #$10
  sta DMAPaletteOffset
prepare_for_palette_uploader_loop:
  inx
  inx
  cpx #$10
  bne palette_uploader_loop

done:
  rts

.endproc

PaletteAddressTable:
  .word Player1Palette,BulletPalette