.segment "CODE"

;
; start_palette_checker
; 
.proc start_palette_checker
  phy
  sep #$30
  tay

  lda Attributes+1
  and #%11110001
  ora a:TotalPalettesTable-1,y
  sta Attributes+1
  ;lda a:TotalPalettesTable2-2,y
  ;inc
  ;sta a:TotalPalettesTable2-2,y
  lda a:TotalPalettesTable2-1,y
  beq start_palette_checker_loop

  ply
  rts

start_palette_checker_loop:
  phx
  ldx #$00

palette_checker_loop:
  lda a:OnscreenPaletteTable,x
  beq palette_checker_loop_done

prepare_for_palette_checker_loop:
  inx
  inx
  cpx #$10
  bcs palette_slot_not_found
  bra palette_checker_loop

palette_checker_loop_done:
  txa
  sta a:TotalPalettesTable-1,y
  and #$0E
  sta Attributes+1

  tya
  sta a:OnscreenPaletteTable,x

  lda #$01
  sta a:TotalPalettesTable2-1,y

palette_slot_not_found:
  ply
  plx
  rts

.endproc